## Script (Python) "phc_getSectionMap"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Get section map for helpcenter_topicview
## Script (Python) "phc_getSectionMap"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Get section map for helpcenter_topicview

from Products.PythonScripts.standard import url_quote_plus

here_url  = context.absolute_url()
phc = context.getPHCObject()

topics = phc.getSectionsVocab()

# dict to save counts
topicsDict = {}

for topic in topics:
    if ':' not in topic:
        items = context.portal_catalog(portal_type=['HelpCenterReferenceManual','HelpCenterTutorial','HelpCenterHowTo'],
                                       review_state='published',
                                       getSections=[topic])
        for item in items:
            for section in item.getSections:
                topicsDict[section] = topicsDict.get(section, 0) + 1

sections = []
currTitle = ''
for topic in topics:
    count = topicsDict.get(topic)
    if count:
        # break into main topic, sub topic
        cs = [s.strip() for s in topic.split(':')]
        main = cs[0]
        sub = ': '.join(cs[1:])
        
        if main != currTitle:
            # append a new topic dict
            currTitle = main
            currSubSections = []
            sections.append(
             {'title':currTitle,
              'subtopics':currSubSections,
              'url': here_url + '/phc_topic_area?topic=' + url_quote_plus(currTitle),
              'count':count
              }
             )
        if sub:
            # add to the subtopics list
            id = sub.lower().replace(' ','-')  # make HTML anchor ID
            currSubSections.append(
             {'title':sub,
              'url': "%s/phc_topic_area?topic=%s#%s" % (here_url, url_quote_plus(currTitle), id)
              }
             )
    
return sections