## Script (Python) "phc_queryCatalog"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST=None
##title=Find documentation items based on a statistics query

from Products.CMFCore.utils import getToolByName

if REQUEST is None:
    REQUEST = context.REQUEST

herePath = REQUEST.get('path', '/'.join(context.getPhysicalPath()))    
catalog = getToolByName(context, 'portal_catalog')

catalogMatches = context.queryCatalog(REQUEST=REQUEST, use_types_blacklist=False)
matches = [m for m in catalogMatches]

# Now do checks for comments, multiple sections/audiences/versions

multipleSections = REQUEST.get('getSections_multiple', False)
if multipleSections:
    matches = [m for m in matches if len(m.getSections) > 1]
    
noSections = REQUEST.get('getSections_none', False)
if noSections:
    matches = [m for m in matches if len(m.getSections) == 0]
    
multipleAudiences = REQUEST.get('getAudiences_multiple', False)
if multipleAudiences:
    matches = [m for m in matches if len(m.getAudiences) > 1]

multipleVersions = REQUEST.get('getVersions_multiple', False)
if multipleVersions:
    matches = [m for m in matches if len(m.getVersions) > 1]
    
noVersions = REQUEST.get('getVersions_none', False)
if noVersions:
    matches = [m for m in matches if len(m.getVersions) == 0]
    
hasComments = REQUEST.get('hasComments', False)
if hasComments:
    matchedPaths = [m.getPath() for m in matches]
    comments = catalog.searchResults(path = matchedPaths, 
                                     portal_type = 'Discussion Item')
                                     
    foundPaths = {}
    for c in comments:
        path = c.getPath()
        idx = path.rfind('/talkback')
        path = path[:idx]
        id = path.split('/')[-1]
        foundPaths[path] = 1
        
    matches = [m for m in matches if m.getPath() in foundPaths]
        
return matches
                            